# class Puppet::Application::Resource

### Attributes

extra_params[RW]
host[RW]

### Public Instance Methods

help() click to toggle source

    # File lib/puppet/application/resource.rb, line 35
      def help
        <<-'HELP'

    puppet-resource(8) -- The resource abstraction layer shell
    ========

    SYNOPSIS
    --------
    Uses the Puppet RAL to directly interact with the system.

    USAGE
    -----
    puppet resource [-h|--help] [-d|--debug] [-v|--verbose] [-e|--edit]
      [-H|--host <host>] [-p|--param <parameter>] [-t|--types] <type>
      [<name>] [<attribute>=<value> ...]

    DESCRIPTION
    -----------
    This command provides simple facilities for converting current system
    state into Puppet code, along with some ability to modify the current
    state using Puppet's RAL.

    By default, you must at least provide a type to list, in which case
    puppet resource will tell you everything it knows about all resources of
    that type. You can optionally specify an instance name, and puppet
    resource will only describe that single instance.

    If given a type, a name, and a series of <attribute>=<value> pairs,
    puppet resource will modify the state of the specified resource.
    Alternately, if given a type, a name, and the '--edit' flag, puppet
    resource will write its output to a file, open that file in an editor,
    and then apply the saved file as a Puppet transaction.

    OPTIONS
    -------
    Note that any configuration parameter that's valid in the configuration
    file is also a valid long argument. For example, 'ssldir' is a valid
    configuration parameter, so you can specify '--ssldir <directory>' as an
    argument.

    See the configuration file documentation at
    http://docs.puppetlabs.com/references/stable/configuration.html for the
    full list of acceptable parameters. A commented list of all
    configuration options can also be generated by running puppet with
    '--genconfig'.

    * --debug:
      Enable full debugging.

    * --edit:
      Write the results of the query to a file, open the file in an editor,
      and read the file back in as an executable Puppet manifest.

    * --host:
      When specified, connect to the resource server on the named host
      and retrieve the list of resouces of the type specified.

    * --help:
      Print this help message.

    * --param:
      Add more parameters to be outputted from queries.

    * --types:
      List all available types.

    * --verbose:
      Print extra information.

    EXAMPLE
    -------
    This example uses `puppet resource` to return a Puppet configuration for
    the user `luke`:

        $ puppet resource user luke
        user { 'luke':
         home => '/home/luke',
         uid => '100',
         ensure => 'present',
         comment => 'Luke Kanies,,,',
         gid => '1000',
         shell => '/bin/bash',
         groups => ['sysadmin','audio','video','puppet']
        }

    AUTHOR
    ------
    Luke Kanies

    COPYRIGHT
    ---------
    Copyright (c) 2011 Puppet Labs, LLC Licensed under the Apache 2.0 License

        HELP
      end

main() click to toggle source

    # File lib/puppet/application/resource.rb, line 137
    def main
      type, name, params = parse_args(command_line.args)

      raise "You cannot edit a remote host" if options[:edit] and @host

      resources = find_or_save_resources(type, name, params)
      text = resources.
        map { |resource| resource.prune_parameters(:parameters_to_include => @extra_params).to_manifest }.
        join("\n")

      options[:edit] ?
        handle_editing(text) :
        (puts text)
    end

preinit() click to toggle source

    # File lib/puppet/application/resource.rb, line 7
    def preinit
      @extra_params = []
      Facter.loadfacts
    end

setup() click to toggle source

    # File lib/puppet/application/resource.rb, line 152
    def setup
      Puppet::Util::Log.newdestination(:console)

      if options[:debug]
        Puppet::Util::Log.level = :debug
      elsif options[:verbose]
        Puppet::Util::Log.level = :info
      end
    end